> For the complete documentation index, see [llms.txt](https://docs.feast.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.feast.dev/v0.28-branch/reference/data-sources/overview.md).

# Overview

## Functionality

In Feast, each batch data source is associated with a corresponding offline store. For example, a `SnowflakeSource` can only be processed by the Snowflake offline store. Otherwise, the primary difference between batch data sources is the set of supported types. Feast has an internal type system, and aims to support eight primitive types (`bytes`, `string`, `int32`, `int64`, `float32`, `float64`, `bool`, and `timestamp`) along with the corresponding array types. However, not every batch data source supports all of these types.

For more details on the Feast type system, see [here](/v0.28-branch/reference/type-system.md).

## Functionality Matrix

There are currently four core batch data source implementations: `FileSource`, `BigQuerySource`, `SnowflakeSource`, and `RedshiftSource`. There are several additional implementations contributed by the Feast community (`PostgreSQLSource`, `SparkSource`, and `TrinoSource`), which are not guaranteed to be stable or to match the functionality of the core implementations. Details for each specific data source can be found [here](/v0.28-branch/reference/data-sources.md).

Below is a matrix indicating which data sources support which types.

|             | File | BigQuery | Snowflake | Redshift | Postgres | Spark | Trino |
| ----------- | ---- | -------- | --------- | -------- | -------- | ----- | ----- |
| `bytes`     | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `string`    | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `int32`     | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `int64`     | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `float32`   | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `float64`   | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `bool`      | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| `timestamp` | yes  | yes      | yes       | yes      | yes      | yes   | yes   |
| array types | yes  | yes      | no        | no       | yes      | yes   | no    |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.feast.dev/v0.28-branch/reference/data-sources/overview.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
